#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_Global_Config.h"
#include "FileEncrypt.h"
std::auto_ptr<M_Global_Config> M_Global_Config::msSingleton(nullptr);

int M_Global_Config::GetCount()
{
	return (int)mMapData.size();
}

const M_Global_ConfigData* M_Global_Config::GetData(std::string Key)
{
	auto it = mMapData.find(Key);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<std::string, M_Global_ConfigData>& M_Global_Config::GetMapData()
{
	return mMapData;
}

void M_Global_Config::Reload()
{
	mMapData.clear();
	Load();
}

void M_Global_Config::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_Global_ConfigData data;
		data.mKey = element->Attribute("Key");
		data.mDesc = element->Attribute("Desc");
		data.mIntValue = element->IntAttribute("IntValue");
		{
			const char* IntListValue = element->Attribute("IntListValue");
			std::vector<std::string> vecIntListValue;
			boost::split(vecIntListValue, IntListValue, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecIntListValue.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecIntListValue[i].c_str(), &temp))
				{
					data.mIntListValue.push_back(temp);
				}
			}
		}
		data.mStrValue = element->Attribute("StrValue");
		{
			const char* StrListValue = element->Attribute("StrListValue");
			std::vector<std::string> vecStrListValue;
			boost::split(vecStrListValue, StrListValue, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecStrListValue.size(); i++)
			{
				data.mStrListValue.push_back(vecStrListValue[i]);
			}
		}
		data.mBoolValue = element->BoolAttribute("BoolValue");
		if (mMapData.find(data.mKey) != mMapData.end())std::cout <<"data refind:" << data.mKey << std::endl;
		assert(mMapData.find(data.mKey) == mMapData.end());
		mMapData.insert(std::make_pair(data.mKey, data));
		element = element->NextSiblingElement();
	}
}

void M_Global_Config::Load()
{
	Load("../Config/M_Global_Config.xml");
}

M_Global_Config* M_Global_Config::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_Global_Config());
	}
	return msSingleton.get();
}
